#cs ----------------------------------------------------------------------------

 AutoIt Version: 3.3.14.5
 Author: SHDF/CETIPABO

 Script Function:
	Interroge l'API de la livebox pour obtenir les options DHCP IPV4/IPV6 nécessaires à l'authentification

#ce ----------------------------------------------------------------------------

#include <ButtonConstants.au3>
#include <EditConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <Json.au3>
#Region ### START Koda GUI section ### Form=
$Form1 = GUICreate("OPTIONS DHCP ORANGE - V1.0", 989, 393, 192, 124)
$Group1 = GUICtrlCreateGroup("CONNEXION", 16, 8, 689, 57)
$Label9 = GUICtrlCreateLabel("USER :", 200, 32, 40, 17)
$Input10 = GUICtrlCreateInput("admin", 240, 32, 121, 21)
$Label10 = GUICtrlCreateLabel("PASS :", 384, 32, 38, 17)
$Input11 = GUICtrlCreateInput("", 424, 32, 121, 21)
$Label11 = GUICtrlCreateLabel("IP :", 32, 32, 20, 17)
$Input9 = GUICtrlCreateInput("192.168.1.1", 56, 32, 121, 21)
$Button1 = GUICtrlCreateButton("CONNEXION", 584, 32, 75, 21)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$Group2 = GUICtrlCreateGroup("DHCP V4", 16, 80, 937, 129)
$Label1 = GUICtrlCreateLabel("60 :", 32, 104, 22, 17)
$Input1 = GUICtrlCreateInput("", 64, 104, 113, 21)
$Label2 = GUICtrlCreateLabel("61 : ", 208, 104, 25, 17)
$Input2 = GUICtrlCreateInput("", 240, 104, 121, 21)
$Label3 = GUICtrlCreateLabel("77 : ", 32, 136, 25, 17)
$Input3 = GUICtrlCreateInput("", 64, 136, 585, 21)
$Label4 = GUICtrlCreateLabel("90 : ", 32, 168, 25, 17)
$Input4 = GUICtrlCreateInput("", 64, 168, 873, 21)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$Group3 = GUICtrlCreateGroup("DHCP V6", 16, 224, 937, 137)
$Label5 = GUICtrlCreateLabel("11 : ", 32, 248, 25, 17)
$Input5 = GUICtrlCreateInput("", 64, 248, 873, 21)
$Label6 = GUICtrlCreateLabel("15 : ", 32, 280, 25, 17)
$Input6 = GUICtrlCreateInput("", 64, 280, 585, 21)
$Label7 = GUICtrlCreateLabel("16 : ", 32, 312, 25, 17)
$Input7 = GUICtrlCreateInput("", 64, 312, 161, 21)
$Label8 = GUICtrlCreateLabel("17 : ", 256, 312, 25, 17)
$Input8 = GUICtrlCreateInput("", 288, 312, 305, 21)
GUICtrlCreateGroup("", -99, -99, 1, 1)

$Rect_Rouge = GUICtrlCreateGraphic(664, 32, 32, 24)
GUICtrlSetGraphic(-1, $GUI_GR_COLOR, 0x000000, 0xFF0000)
GUICtrlSetGraphic(-1, $GUI_GR_RECT, 0, 0, 30, 21)

$Rect_Vert = GUICtrlCreateGraphic(664, 32, 32, 24)
GUICtrlSetGraphic(-1, $GUI_GR_COLOR, 0x000000, 0x008000)
GUICtrlSetGraphic(-1, $GUI_GR_RECT, 0, 0, 30, 21)
GUICtrlSetState(-1, $GUI_HIDE)

GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

Global $cookie, $LIVEBOX, $PASSWORD, $USER, $connexion

$connexion = ""
$sContextID = ""

$oHTTP = ObjCreate("winhttp.winhttprequest.5.1")


While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			if ($nMsg = $GUI_EVENT_CLOSE) then
				if ($sContextID <>"") Then
					; Logout si on est connecté
					$PARAMS = '{"service":"sah.Device.Information","method":"releaseContext","parameters":{"applicationName":"so_sdkut"}}'
					$oHTTP.Open("POST", "http://" & $LIVEBOX & "/ws", False)
					$oHTTP.SetRequestHeader("Content-Type", "application/x-sah-ws-4-call+json")
					$oHTTP.SetRequestHeader("X-Context", $sContextID)
					$oHTTP.SetRequestHeader("cookie", $cookie & "; sah/contextId=" & $sContextID)
					$oHTTP.Send($PARAMS)
					$oHTTP = 0
				Exit
				Else
					exit
				endif
			EndIf

		Case $Button1
			$LIVEBOX = GUICtrlRead($Input9)
			$USER = GUICtrlRead($Input10)
			$PASSWORD = GUICtrlRead($Input11)

			auth_livebox()
			if $connexion=="OK" Then

			; Voyant Vert Allumé
			GUICtrlSetState($Rect_Rouge, $GUI_HIDE)
			GUICtrlSetState($Rect_Vert, $GUI_SHOW )

			; Recuperation des donnees MIBs
			$PARAMS = '{"service":"NeMo.Intf.data","method":"getMIBs","parameters":{}}'
			$oHTTP.Open("POST", "http://" & $LIVEBOX & "/ws", False)
			$oHTTP.SetRequestHeader("Content-Type", "application/x-sah-ws-4-call+json")
			$oHTTP.SetRequestHeader("X-Context", $sContextID)
			$oHTTP.SetRequestHeader("cookie", $cookie & "; sah/contextId="&$sContextID)
			$oHTTP.Send($PARAMS)
			$getMIBs = $oHTTP.ResponseText

			;Traitement getMIBs
			$dhcp_MIBS = Json_Decode($getMIBs)
			$MIBS_dhcp60 = Json_Get($dhcp_MIBS, '["status"]["dhcp"]["dhcp_data"]["SentOption"]["60"]["Value"]')
			$MIBS_dhcp61 = Json_Get($dhcp_MIBS, '["status"]["dhcp"]["dhcp_data"]["SentOption"]["61"]["Value"]')
			$MIBS_dhcp77 = Json_Get($dhcp_MIBS, '["status"]["dhcp"]["dhcp_data"]["SentOption"]["77"]["Value"]')
			$MIBS_dhcp90 = Json_Get($dhcp_MIBS, '["status"]["dhcp"]["dhcp_data"]["SentOption"]["90"]["Value"]')

			$MIBS_dhcp11 = Json_Get($dhcp_MIBS, '["status"]["dhcpv6"]["dhcpv6_data"]["SentOption"]["11"]["Value"]')
			$MIBS_dhcp15 = Json_Get($dhcp_MIBS, '["status"]["dhcpv6"]["dhcpv6_data"]["SentOption"]["15"]["Value"]')
			$MIBS_dhcp16 = Json_Get($dhcp_MIBS, '["status"]["dhcpv6"]["dhcpv6_data"]["SentOption"]["16"]["Value"]')
			$MIBS_dhcp17 = Json_Get($dhcp_MIBS, '["status"]["dhcpv6"]["dhcpv6_data"]["SentOption"]["17"]["Value"]')

			GUICtrlSetData($Input1,$MIBS_dhcp60)
			GUICtrlSetData($Input2,$MIBS_dhcp61)
			GUICtrlSetData($Input3,$MIBS_dhcp77)
			GUICtrlSetData($Input4,$MIBS_dhcp90)

			GUICtrlSetData($Input5,$MIBS_dhcp11)
			GUICtrlSetData($Input6,$MIBS_dhcp15)
			GUICtrlSetData($Input7,$MIBS_dhcp16)
			GUICtrlSetData($Input8,$MIBS_dhcp17)

			EndIf

	EndSwitch
WEnd


Func auth_livebox()
	; On vérifie que la Livebox est bien sur l'IP indiquée et qu'elle répond
	;$iplivebox = StringSplit($LIVEBOX,":")
	;$ping = ping($iplivebox[1])
	;if $ping = 0 then
	;	MsgBox(0,'Erreur de connexion',"La Livebox n'est pas joignable sur l'IP : " & $LIVEBOX)

	;Else

	$PARAMSlogin = '{"service":"sah.Device.Information","method":"createContext","parameters":{"applicationName":"so_sdkut","username":"'& $USER &'","password":"' & $PASSWORD & '"}}'

	$oHTTP.Open("POST", "http://" & $LIVEBOX & "/ws", False)
	$oHTTP.SetRequestHeader("Content-Type", "application/x-sah-ws-4-call+json")
	$oHTTP.SetRequestHeader("Authorization", "X-Sah-Login")
	$oHTTP.Send($PARAMSlogin)
	$oReceived = $oHTTP.ResponseText
	$sResult = Json_Decode($oReceived)
	$sContextID = Json_Get($sResult, '["data"]["contextID"]')
		If $sContextID == "" Then
			MsgBox(48, "ERREUR", "aucun ContextID reçu, erreur d'authentification")
			$connexion = ""
		Else
		$cookie = $oHTTP.getResponseHeader("Set-Cookie")
		$connexion = "OK"
		EndIf
	;EndIf

EndFunc   ;==>auth_livebox